using PSO2SERVER.Models;
using PSO2SERVER.Zone;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PSO2SERVER.Protocol.Packets
{
    public class TransporterSpawnPacket : Packet
    {
        public ObjectHeader objHeader { get; set; } = new ObjectHeader();
        public PSOLocation objPosition { get; set; } = new PSOLocation();
        public ushort unk1 { get; set; } = 0;
        /// Enemy name.
        public string objName { get; set; } = string.Empty;//0x20
        public uint unk2 { get; set; } = 0;
        public ushort unk3 { get; set; } = 0;
        public ushort unk4 { get; set; } = 0;
        public ushort unk5 { get; set; } = 0;
        public ushort unk6 { get; set; } = 0;
        public uint unk7 { get; set; } = 0;
        public uint unk8 { get; set; } = 0;


        public TransporterSpawnPacket(PSOObject obj)
        {
            objHeader = obj.Header;
            objPosition = obj.Position;
            objName = obj.Name;
        }

        #region implemented abstract members of Packet

        public override byte[] Build()
        {
            var pkt = new PacketWriter();
            pkt.WriteStruct(objHeader);
            pkt.WritePosition(objPosition);
            pkt.Write(unk1); // Padding?
            pkt.WriteFixedLengthASCII(objName, 0x20);
            pkt.Write(unk2);
            pkt.Write(unk3);
            pkt.Write(unk4);
            pkt.Write(unk5);
            pkt.Write(unk6);
            pkt.Write(unk7);
            pkt.Write(unk8);
            return pkt.ToArray();
        }

        public override PacketHeader GetHeader()
        {
            return new PacketHeader(0x08, 0x05, PacketFlags.None);
        }

        #endregion
    }
}